import ktc
import numpy as np
import os
from os import walk
import onnx
from PIL import Image

onnx_path = 'yolov5n-hagrid4k_se_half_add_snape4k_half_rechecked_aug_add_snape4k_half_aug_192x640_lkr_best_0107_simplify.onnx'
m = onnx.load(onnx_path)
m = ktc.onnx_optimizer.onnx2onnx_flow(m)
onnx.save(m,'yolov5n-hagrid4k_se_half_add_snape4k_half_rechecked_aug_add_snape4k_half_aug_192x640_lkr_best_0107_onnx_simplify_optimized.onnx')

# npu (only) performance simulation
km = ktc.ModelConfig(20008, "0001", "720", onnx_model=m)
eval_result = km.evaluate()
print("\nNpu performance evaluation result:\n" + str(eval_result))

img_list = []
for (dirpath, dirnames, filenames) in walk("voc_data50"):
    for f in filenames:
        fullpath = os.path.join(dirpath, f)
        
        image = Image.open(fullpath)
        image = image.convert("RGB")
        image = Image.fromarray(np.array(image)[...,::-1])
        img_data = np.array(image.resize((640, 192), Image.BILINEAR)) / 255
        img_data = img_data.transpose(2, 0 ,1)[None]
        print(fullpath)
        img_list.append(img_data)

# fixed-point analysis
bie_model_path = km.analysis({"images": img_list})
print("\nFixed-point analysis done. Saved bie model to '" + str(bie_model_path) + "'")

# compile
nef_model_path = ktc.compile([km])
print("\nCompile done. Saved Nef file to '" + str(nef_model_path) + "'")